#ifndef GENER_H
#define GENER_H
/****************************************************************************

FILE	gener.h

PURPOSE 
    	Auxilary function prototypes, defined in gener.c, used in grammar file.
*****************************************************************************/
/*****************************************************************************                                                                              
 Copyright (c) 1995
      Robert J. Mercier
 Copyright 2000
      Vahur Krouverk

THIS CODE IS SUPPLIED ``AS IS'' WITH NO WARRANTY EXPRESSED
OR IMPLIED.  NO CLAIMS IS MADE TO IT'S SUITABILITY FOR
ANY PURPOSE AND NO RESPONSIBILITY IS ACCEPTED FOR ANY DAMAGES
OF ANY KIND RESULTING FROM IT'S USE.

When (if) this code is included into POV the usual POV legal stuff will apply.

*****************************************************************************/

#include "shade.h"

struct ilist *merge(struct ilist *p1, struct ilist *p2);
struct ilist *mkilist(int n);


int genbackcopy(struct tree *t);
int  gen_arr_initializer(int type, int dim, int initial_offset, struct tree * initializers);
struct tree * arithnode(int op, struct tree *l, struct tree *r);
int assigntype(int lty, int rty);
struct tree *  relequiv(int op, int op3, struct tree *l, struct tree *r);
struct tree *  relop(int op, struct tree *l, struct tree *r);
int tlen(struct tree *t);
void check_params(struct func_tree *function, struct tree *param_list);
int check_list_args(struct tree *p);

#endif
