#ifndef OPCODES_H
#define OPCODES_H
/****************************************************************************

FILE	opcodes.h

PURPOSE 
    	Values for shading language operation codes.

*****************************************************************************/
/*****************************************************************************                                                                              
 Copyright (c) 1995
      Robert J. Mercier
 Copyright 2000
      Vahur Krouverk

THIS CODE IS SUPPLIED ``AS IS'' WITH NO WARRANTY EXPRESSED
OR IMPLIED.  NO CLAIMS IS MADE TO IT'S SUITABILITY FOR
ANY PURPOSE AND NO RESPONSIBILITY IS ACCEPTED FOR ANY DAMAGES
OF ANY KIND RESULTING FROM IT'S USE.

When (if) this code is included into POV the usual POV legal stuff will apply.

*****************************************************************************/
enum opcodes{
oABS=1,
oACOS,
oADD,
oADD3,
oADDEQ,
oADDEQ3,
oAMBIENT,
oAREA,
oARR,
oARR3,
oASIN,
oASSIGN,
oASSIGN3,
oASSIGNS,
oATAN,
oATAN2,
oCALCULATENORMAL,
oCALL,
oCEIL,
oCELLNOISE,
oCELLNOISE3,
oCF2T,
oCHK,
oCLAMP,
oCLAMP3,
oCOMP,
oCOS,
oCROSSP,
oCTRANSFORM,
oDEGREES,
oDEPTH,
oDERIV,
oDERIV3,
oDIFFUSE,
oDISTANCE,
oDIV,
oDIV3,
oDIVEQ,
oDIVEQ3,
oDOTP,
oDU,
oDU3,
oDV,
oDV3,
oEND,
oENDINIT,
oEQ,
oEQ3,
oEQS,
oEXP,
oFSTART,
oFACEFORWARD,
oFLOOR,
oFRESNEL,
oFRESNEL2,
oGE,
oGT,
oILLUM1,
oILLUM3,
oINVSQRT,
oJMP,
oLE,
oLENGTH,
oLOG,
oLOG2,
oLT,
oMAX,
oMAX3,
oMIN,
oMIN3,
oMIX,
oMIX3,
oMOD,
oMUL,
oMUL3,
oMULEQ,
oMULEQ3,
oNE,
oNE3,
oNES,
oNEGATE,
oNEGATE3,
oNOISE,
oNOISE3,
oNORMALIZE,
oNTRANSFORM,
oPHONG,
oPI,
oPNOISE,
oPNOISE3,
oPOP,
oPOP3,
oPOW,
oPRINTF,
oPTLINED,
oPUSH,
oPUSH3,
oPUSHALEN,
oPUSHARR,
oPUSHARR3,
oPUSHC,
oPUSHS,
oRADIANS,
oRANDOM,
oRANDOM3,
oREFLECT,
oREFRACT,
oRET,
oROTATE,
oROUND,
oSETCOMP,
oSETXCOMP,
oSETYCOMP,
oSETZCOMP,
oSIGN,
oSIN,
oSMOOTHSTEP,
oSPECULAR,
oSPECULARBRDF,
oSPLINE,
oSPLINE3,
oSQR,
oSQRT,
oSTEP,
oSUB,
oSUB3,
oSUBEQ,
oSUBEQ3,
oTAN,
oTRACE,
oTRANSFORM,
oVTRANSFORM,
oXCOMP,
oYCOMP,
oZCOMP
};

#endif /* OPCODES_H */
